CodeForces - 280C Game on Tree 概率期望

Momiji has got a rooted tree, consisting of n nodes. The tree nodes are numbered by integers from 1 to n. The root has number 1. Momiji decided to play a game on this tree.

The game consists of several steps. On each step, Momiji chooses one of the remaining tree nodes (let's denote it by v) and removes all the subtree nodes with the root in node v from the tree. Node v gets deleted as well. The game finishes when the tree has no nodes left. In other words, the game finishes after the step that chooses the node number 1.

Each time Momiji chooses a new node uniformly among all the remaining nodes. Your task is to find the expectation of the number of steps in the described game.

Input

The first line contains integer n (1 ≤ n ≤ 105) — the number of nodes in the tree. The next n - 1 lines contain the tree edges. The i-th line contains integers aibi(1 ≤ ai, bi ≤ nai ≠ bi) — the numbers of the nodes that are connected by the i-th edge.

It is guaranteed that the given graph is a tree.

Output

Print a single real number — the expectation of the number of steps in the described game.

The answer will be considered correct if the absolute or relative error doesn't exceed 10 - 6.

Examples

Input

2
1 2

Output

1.50000000000000000000

Input

3
1 2
1 3

Output

2.00000000000000000000

Note

In the first sample, there are two cases. One is directly remove the root and another is remove the root after one step. Thus the expected steps are:

1 × (1 / 2) + 2 × (1 / 2) = 1.5

In the second sample, things get more complex. There are two cases that reduce to the first sample, and one case cleaned at once. Thus the expected steps are:

1 × (1 / 3) + (1 + 1.5) × (2 / 3) = (1 / 3) + (5 / 3) = 2

题解:因为要求把所有点都选完的次数的期望,那我们就可以把每个点的期望算出来加和就可以了,对于某一节点,若他为第k代,那么选它的概率就为1 / k  因为选他的祖先时,它也就不能选了,对应的期望就为 1 / k

#include<iostream>
#include<cstdio>
#include<vector>
using namespace std;
const int N=1e5+10;
typedef long long ll;
int n,deep[N];
double ans;
vector<int> v[N];
void dfs(int fa,int u)
{
	deep[u]=deep[fa]+1;
	ans+=1/(double)deep[u];
	for(int i=0;i<v[u].size();i++)
	{
		int to=v[u][i];
		if(to==fa) continue;
		dfs(u,to);
	}
}
int main()
{
	int x,y;
	while(~scanf("%d",&n))
	{
		ans=0;
		for(int i=1;i<=n;i++) v[i].clear();
		for(int i=1;i<n;i++)
		{
			scanf("%d%d",&x,&y);
			v[x].push_back(y);
			v[y].push_back(x);
		}
		dfs(0,1);
		printf("%.10f\n",ans);
	}
	return 0;
}

猜你喜欢

转载自blog.csdn.net/mmk27_word/article/details/84296740
今日推荐